.e2e-test-patterns: &e2e-test-patterns
  - "api/**/*"
  - "controllers/**/*"
  - "consts/**/*"
  - .gitlab/ci/test.yaml
  - go.mod

.if-merge-request: &if-merge-request
  if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
.if-commit-master: &if-commit-master
  if: '$CI_COMMIT_REF_NAME == "master"'

.gotest-rules:
  rules:
    - <<: *if-merge-request
      changes: *e2e-test-patterns
    - <<: *if-commit-master
      when: always

gotest:
  image: golang:1.18.6
  stage: unit-test
  extends:
    - .gotest-rules
  tags:
    - gitlab-org-docker
  script:
    - make test
